.\"	$OpenBSD: tl.4,v 1.21 2013/06/02 20:23:34 tedu Exp $
.\"
.\" Copyright (c) 1997, 1998
.\"	Bill Paul <wpaul@ctr.columbia.edu>. All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by Bill Paul.
.\" 4. Neither the name of the author nor the names of any co-contributors
.\"    may be used to endorse or promote products derived from this software
.\"   without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY Bill Paul AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL Bill Paul OR THE VOICES IN HIS HEAD
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
.\" THE POSSIBILITY OF SUCH DAMAGE.
.\"
.\"	$Id: tl.4,v 1.21 2013/06/02 20:23:34 tedu Exp $
.\"
.Dd $Mdocdate: June 2 2013 $
.Dt TL 4
.Os
.Sh NAME
.Nm tl
.Nd Texas Instruments ThunderLAN 10/100 Ethernet device
.Sh SYNOPSIS
.Cd "tl* at pci?"
.Cd "lxtphy* at mii?"
.Cd "mlphy* at mii?"
.Cd "nsphy* at mii?"
.Cd "tlphy* at mii?"
.Sh DESCRIPTION
The
.Nm
driver provides support for PCI Ethernet adapters based on the Texas
Instruments ThunderLAN Ethernet controller chip.
This includes a large number of Compaq PCI-bus Ethernet adapters as well as
the integrated Ethernet controllers built in to several models
of Compaq Prosignia servers and Compaq Deskpro desktop machines.
This driver also supports the Olicom OC-2135/2138, OC-2325 and OC-2326
10/100 TX UTP adapters and the Racore 8165 10/100baseTX and 8148
10baseT/100baseTX/100baseFX multi-personality cards.
.Pp
The ThunderLAN controller has a standard MII interface that supports
up to 32 physical interface devices (PHYs).
It also has a built-in 10baseT PHY hardwired at MII address 31, which may be
used in some 10Mbps-only hardware configurations.
In 100Mbps configurations, a National Semiconductor DP83840A or other
MII-compliant PHY may be attached to the ThunderLAN's MII bus.
If a DP83840A or equivalent is available, the ThunderLAN chip can operate
at either 100Mbps or 10Mbps in either half-duplex or full-duplex modes.
The ThunderLAN's built-in PHY and the DP83840A also support autonegotiation.
.Pp
The
.Nm
driver supports the following media types:
.Bl -tag -width full-duplex
.It autoselect
Enable autoselection of the media type and options.
Note that this option is only available on those PHYs that support
autonegotiation.
Also, the PHY will not advertise those modes that have been explicitly
disabled using the following media options.
.It 10baseT
Set 10Mbps operation.
.It 100baseTX
Set 100Mbps (Fast Ethernet) operation.
.It 10base5
Enable AUI/BNC interface (useful only with the built-in PHY).
.El
.Pp
The
.Nm
driver supports the following media options:
.Bl -tag -width full-duplex
.It full-duplex
Force full duplex operation.
.It half-duplex
Force half duplex operation.
.It hw-loopback
Enable hardware loopback mode.
.El
.Pp
Note that the 100baseTX media type is only available if supported
by the PHY.
For more information on configuring this device, see
.Xr ifconfig 8 .
.Sh DIAGNOSTICS
.Bl -diag
.It "tl0: couldn't map memory"
A fatal initialization error has occurred.
.It "tl0: couldn't map interrupt"
A fatal initialization error has occurred.
.It "tl0: device timeout"
The device has stopped responding to the network, or there is a problem with
the network connection (cable).
.It "tl0: no memory for rx list"
The driver failed to allocate an mbuf for the receiver ring.
.It "tl0: no memory for tx list"
The driver failed to allocate an mbuf for the transmitter ring when
allocating a pad buffer or collapsing an mbuf chain into a cluster.
.El
.Sh SEE ALSO
.Xr arp 4 ,
.Xr ifmedia 4 ,
.Xr intro 4 ,
.Xr lxtphy 4 ,
.Xr mlphy 4 ,
.Xr netintro 4 ,
.Xr nsphy 4 ,
.Xr pci 4 ,
.Xr tlphy 4 ,
.Xr hostname.if 5 ,
.Xr ifconfig 8
.Sh HISTORY
The
.Nm
device driver first appeared in
.Fx 2.2 .
.Ox
support first appeared in
.Ox 2.4 .
.Sh AUTHORS
The
.Nm
driver was written by
.An Bill Paul Aq wpaul@ctr.columbia.edu .
